#  String module (string.io)
#  Amalthea standard Io library
#  (c)2002 Martin Sandin (msandin@hotmail.com)
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

import prelude.
export
  concat_strings
  ^
  print_string
  print_string_
  int_of_string
  substring
  string_length.

# Interface
#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #
primitive ^: string_concat.
primitive print_string: string_print_endline.
primitive print_string_: string_print.
primitive int_of_string: string_to_int.
primitive substring: string_sub.
primitive string_length: string_length.

declare concat_strings: -> glue list return;
    _concat_strings glue list "" return.

# Private
#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #

declare _concat_strings: -> glue list acc return;
  list (return acc) -> item list;
  ^ acc item -> acc;
  list (return acc) -> _ _;
  ^ acc glue -> acc;
  _concat_strings glue list acc return.


# Demo
#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #

print_string "Amalthea standard Io library: String module";

print_string "concat_strings: A B C D E";
List_of_5 "A" "B" "C" "D" "E" -> list;
concat_strings " - " list -> s;
print_string s;
terminate
